import { FeedMonitorService } from "./services/feed-monitor-service";
import { ProfileService } from "./services/profile-service";
import { ReadOnlyPostService } from "./services/readonly-post-service";
import { FriendService } from "./services/friend-service";
import { SchemaService } from "./services/schema-service";
import { IdentityService } from "./services/identity-service";
import { ImageService } from "./services/image-service";
import { WalletService } from "./services/wallet-service";
import { PostService } from "./services/post-service";
import { BlogPostService } from "./services/blog-post-service";
import { PageService } from "./services/page-service";
import { SiteSettingsService } from "./services/site-settings-service";
declare namespace Core {
    var initialized: boolean;
    /** Etherjs */
    var provider: any;
    var wallet: any;
    /** Orbit db api reference */
    var orbitDb: any;
    var orbitAccessControl: any;
    /** IPFS api client */
    var ipfs: any;
    var eventEmitter: any;
    var walletService: WalletService;
    var walletDao: WalletDao;
    var feedMonitorService: FeedMonitorService;
    var profileService: ProfileService;
    var siteSettingsService: SiteSettingsService;
    var postService: PostService;
    var blogPostService: BlogPostService;
    var readOnlyPostService: ReadOnlyPostService;
    var feedMonitorPostService: ReadOnlyPostService;
    var pageService: PageService;
    var friendService: FriendService;
    var schemaService: SchemaService;
    var identityService: IdentityService;
    var imageService: ImageService;
    function init(): Promise<void>;
    function loadStoresForWallet(walletAddress: string): Promise<void>;
    function isElectron(): boolean;
}
declare class WalletDao {
    db: any;
    constructor();
    saveWallet(wallet: any): Promise<any>;
    loadWallet(): Promise<any>;
}
export default Core;
