"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var feed_monitor_service_1 = require("./services/feed-monitor-service");
var profile_service_1 = require("./services/profile-service");
var readonly_post_service_1 = require("./services/readonly-post-service");
var friend_service_1 = require("./services/friend-service");
var schema_service_1 = require("./services/schema-service");
var identity_service_1 = require("./services/identity-service");
var image_service_1 = require("./services/image-service");
var events_1 = require("events");
var wallet_service_1 = require("./services/wallet-service");
var post_service_1 = require("./services/post-service");
var blog_post_service_1 = require("./services/blog-post-service");
var page_service_1 = require("./services/page-service");
var site_settings_service_1 = require("./services/site-settings-service");
var levelup = require('levelup');
var leveljs = require('level-js');
var IPFS = require('ipfs');
var OrbitDB = require('orbit-db');
var Keystore = require('orbit-db-keystore');
var _a = require('ethers'), providers = _a.providers, ethers = _a.ethers;
var promisify = function (inner) {
    return new Promise(function (resolve, reject) {
        return inner(function (err, res) {
            if (err) {
                reject(err);
            }
            resolve(res);
        });
    });
};
var Core;
(function (Core) {
    Core.initialized = false;
    function init() {
        return __awaiter(this, void 0, void 0, function () {
            var walletAddress;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Core.schemaService = new schema_service_1.SchemaService();
                        Core.identityService = new identity_service_1.IdentityService();
                        console.log('Setting web3 provider');
                        if (!Core.isElectron()) return [3 /*break*/, 2];
                        return [4 /*yield*/, configureElectron()];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, configureBrowser()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        if (!Core.wallet) {
                            throw new Error("No wallet found. Unable to initialize.");
                        }
                        return [4 /*yield*/, Core.wallet.getAddress()];
                    case 5:
                        walletAddress = _a.sent();
                        console.log("Initializing Large for wallet: " + walletAddress);
                        return [4 /*yield*/, initOrbit()];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, initSchema(walletAddress)];
                    case 7:
                        _a.sent();
                        initServices();
                        //Update user's last know address
                        return [4 /*yield*/, Core.profileService.updateLastKnownAddress()
                            //Connect to online friends
                        ];
                    case 8:
                        //Update user's last know address
                        _a.sent();
                        //Connect to online friends
                        Core.friendService.connectToFriends(walletAddress);
                        //Start feed monitor
                        Core.feedMonitorService.start();
                        console.log("Initialization complete");
                        return [2 /*return*/];
                }
            });
        });
    }
    Core.init = init;
    function loadStoresForWallet(walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Core.blogPostService.loadStoresForWallet(walletAddress)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, Core.friendService.loadStoreForWallet(walletAddress)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, Core.pageService.loadStoresForWallet(walletAddress)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, Core.profileService.loadStoreForWallet(walletAddress)];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, Core.siteSettingsService.loadStoresForWallet(walletAddress)];
                    case 5:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    Core.loadStoresForWallet = loadStoresForWallet;
    function isElectron() {
        var userAgent = navigator.userAgent.toLowerCase();
        var result = (userAgent.indexOf(' electron/') > -1);
        return result;
    }
    Core.isElectron = isElectron;
    function initServices() {
        Core.eventEmitter = new events_1.EventEmitter();
        //Create services
        // Core.identityService = Core.identityService
        Core.imageService = new image_service_1.ImageService(Core.ipfs);
        Core.profileService = new profile_service_1.ProfileService(Core.schemaService);
        Core.siteSettingsService = new site_settings_service_1.SiteSettingsService(Core.schemaService);
        Core.postService = new post_service_1.PostService(Core.schemaService, Core.imageService, Core.profileService);
        Core.blogPostService = new blog_post_service_1.BlogPostService(Core.schemaService, Core.postService);
        Core.readOnlyPostService = new readonly_post_service_1.ReadOnlyPostService(Core.schemaService, Core.postService);
        Core.feedMonitorPostService = new readonly_post_service_1.ReadOnlyPostService(Core.schemaService, Core.postService);
        Core.pageService = new page_service_1.PageService(Core.schemaService, Core.postService);
        Core.friendService = new friend_service_1.FriendService(Core.schemaService, Core.profileService);
        Core.feedMonitorService = new feed_monitor_service_1.FeedMonitorService(Core.schemaService, Core.friendService, Core.feedMonitorPostService);
    }
    function initSchema(walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var mainStore, ex_1, schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, Core.schemaService.getMainStoreByWalletAddress(walletAddress)];
                    case 1:
                        mainStore = _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        ex_1 = _a.sent();
                        console.log(ex_1);
                        return [3 /*break*/, 3];
                    case 3:
                        if (!!mainStore) return [3 /*break*/, 5];
                        return [4 /*yield*/, Core.schemaService.generateMainStore(Core.orbitDb, Core.orbitAccessControl, walletAddress)];
                    case 4:
                        mainStore = _a.sent();
                        _a.label = 5;
                    case 5: return [4 /*yield*/, Core.schemaService.getSchema(mainStore, walletAddress)];
                    case 6:
                        schema = _a.sent();
                        if (!!schema) return [3 /*break*/, 9];
                        return [4 /*yield*/, Core.schemaService.generateSchema(Core.orbitDb, Core.orbitAccessControl, mainStore, walletAddress)];
                    case 7:
                        _a.sent();
                        return [4 /*yield*/, Core.schemaService.getSchema(mainStore, walletAddress)];
                    case 8:
                        schema = _a.sent();
                        _a.label = 9;
                    case 9: 
                    //Update the schema if it needs it.
                    return [4 /*yield*/, Core.schemaService.updateSchema(mainStore, schema, walletAddress)];
                    case 10:
                        //Update the schema if it needs it.
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    function initOrbit() {
        return __awaiter(this, void 0, void 0, function () {
            var keystore, identity, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        keystore = new Keystore();
                        return [4 /*yield*/, Core.identityService.getIdentity(keystore)];
                    case 1:
                        identity = _b.sent();
                        _a = Core;
                        return [4 /*yield*/, OrbitDB.createInstance(Core.ipfs, {
                                identity: identity
                            })];
                    case 2:
                        _a.orbitDb = _b.sent();
                        Core.orbitAccessControl = Core.identityService.getAccessController(Core.orbitDb);
                        return [2 /*return*/];
                }
            });
        });
    }
    function configureWeb3Browser() {
        return __awaiter(this, void 0, void 0, function () {
            var accounts, account, defaultProviders;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!window['ethereum']) return [3 /*break*/, 3];
                        // Request account access
                        return [4 /*yield*/, window['ethereum'].enable()
                            //@ts-ignore
                        ];
                    case 1:
                        // Request account access
                        _a.sent();
                        //@ts-ignore
                        window.web3Provider = window.ethereum;
                        //@ts-ignore
                        web3 = new Web3(window.web3Provider);
                        return [4 /*yield*/, promisify(function (cb) { return web3.eth.getAccounts(cb); })];
                    case 2:
                        accounts = _a.sent();
                        account = accounts[0];
                        window['currentAccount'] = account; //TODO: probably something better
                        //@ts-ignore
                        Core.provider = new providers.Web3Provider(web3.currentProvider);
                        Core.wallet = Core.provider.getSigner();
                        return [3 /*break*/, 4];
                    case 3:
                        defaultProviders = ethers.getDefaultProvider("homestead");
                        Core.provider = defaultProviders.providers[0];
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    function configureWeb3Electron() {
        var defaultProviders = ethers.getDefaultProvider("homestead");
        Core.provider = defaultProviders.providers[0];
    }
    function configureIpfsElectron() {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        //@ts-ignore
                        Core.ipfsHost = remote.getGlobal('ipfsHost');
                        _a = Core;
                        return [4 /*yield*/, IPFS.create({
                                EXPERIMENTAL: {
                                    ipnsPubsub: true
                                },
                                preload: {
                                    enabled: false
                                },
                                relay: {
                                    enabled: true,
                                    hop: {
                                        enabled: true // enable circuit relay HOP (make this node a relay)
                                    }
                                },
                                config: {
                                    Addresses: {
                                        //@ts-ignore
                                        Swarm: ['/dns4/ws-star.discovery.libp2p.io/tcp/443/wss/p2p-websocket-star', Core.ipfsHost]
                                    }
                                }
                            })];
                    case 1:
                        _a.ipfs = _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    function configureIpfsBrowser() {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = Core;
                        return [4 /*yield*/, IPFS.create({
                                EXPERIMENTAL: {
                                    ipnsPubsub: true
                                },
                                preload: {
                                    enabled: false
                                },
                                relay: {
                                    enabled: true,
                                    hop: {
                                        enabled: true // enable circuit relay HOP (make this node a relay)
                                    }
                                },
                                config: {
                                    Addresses: {
                                        //@ts-ignore
                                        Swarm: ['/dns4/ws-star.discovery.libp2p.io/tcp/443/wss/p2p-websocket-star']
                                    }
                                }
                            })];
                    case 1:
                        _a.ipfs = _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    function configureElectron() {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        //@ts-ignore
                        window['remote'] = window.require('electron').remote;
                        //Wallet DAO
                        Core.walletDao = window['remote'].getGlobal('walletDao');
                        //Init service
                        Core.walletService = new wallet_service_1.WalletService(Core.walletDao);
                        //Web 3
                        return [4 /*yield*/, configureWeb3Electron()
                            //IPFS
                        ];
                    case 1:
                        //Web 3
                        _a.sent();
                        //IPFS
                        return [4 /*yield*/, configureIpfsElectron()];
                    case 2:
                        //IPFS
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    function configureBrowser() {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        //Wallet DAO
                        Core.walletDao = new WalletDao();
                        //Init service
                        Core.walletService = new wallet_service_1.WalletService(Core.walletDao);
                        //Web 3
                        return [4 /*yield*/, configureWeb3Browser()
                            //IPFS
                        ];
                    case 1:
                        //Web 3
                        _a.sent();
                        //IPFS
                        return [4 /*yield*/, configureIpfsBrowser()];
                    case 2:
                        //IPFS
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
})(Core || (Core = {}));
var WalletDao = /** @class */ (function () {
    function WalletDao() {
        this.db = levelup(leveljs('large-wallet'));
    }
    WalletDao.prototype.saveWallet = function (wallet) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.db.put('wallet', Buffer.from(JSON.stringify(wallet)))];
            });
        });
    };
    WalletDao.prototype.loadWallet = function () {
        return __awaiter(this, void 0, void 0, function () {
            var value, ex_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.db.get('wallet')];
                    case 1:
                        value = _a.sent();
                        if (value) {
                            return [2 /*return*/, JSON.parse(value.toString())];
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        ex_2 = _a.sent();
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return WalletDao;
}());
exports["default"] = Core;
