import { SchemaService } from "./schema-service";
import { PostService } from "./post-service";
import { BlogPost } from "../dto/blog-post";
declare class BlogPostService {
    private schemaService;
    private postService;
    loadedWalletAddress: string;
    feedStore: any;
    kvStore: any;
    constructor(schemaService: SchemaService, postService: PostService);
    loadStoresForWallet(walletAddress: string): Promise<void>;
    getRecentPosts(offset: number, limit: number, olderThan?: string, newerThan?: string): Promise<BlogPost[]>;
    getPosts(limit: number, olderThan?: string, newerThan?: string): Promise<any>;
    create(post: BlogPost): Promise<BlogPost>;
    update(post: BlogPost): Promise<BlogPost>;
    /**
     * Store post in IPFS. Returns CID.
     * @param post
     */
    private store;
    private translate;
    static read(cid: string): Promise<BlogPost>;
    readPermalink(permalinkKey: string): Promise<BlogPost>;
    delete(post: BlogPost): Promise<void>;
    translatePost(post: BlogPost): Promise<BlogPost>;
    private _generatePermalink;
    count(): number;
    load(amount: any): Promise<void>;
    close(): Promise<void>;
}
export { BlogPostService };
