"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var core_1 = require("../core");
var sha256 = require('js-sha256');
var BlogPostService = /** @class */ (function () {
    function BlogPostService(schemaService, postService) {
        this.schemaService = schemaService;
        this.postService = postService;
    }
    BlogPostService.prototype.loadStoresForWallet = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (walletAddress == this.loadedWalletAddress)
                            return [2 /*return*/];
                        _a = this;
                        return [4 /*yield*/, this.schemaService.getBlogPostFeedByWalletAddress(walletAddress)];
                    case 1:
                        _a.feedStore = _c.sent();
                        _b = this;
                        return [4 /*yield*/, this.schemaService.getBlogPostKvStoreByWalletAddress(walletAddress)];
                    case 2:
                        _b.kvStore = _c.sent();
                        return [4 /*yield*/, this.kvStore.load()];
                    case 3:
                        _c.sent();
                        this.loadedWalletAddress = walletAddress;
                        return [2 /*return*/];
                }
            });
        });
    };
    BlogPostService.prototype.getRecentPosts = function (offset, limit, olderThan, newerThan) {
        if (olderThan === void 0) { olderThan = undefined; }
        if (newerThan === void 0) { newerThan = undefined; }
        return __awaiter(this, void 0, void 0, function () {
            var results, loadQuantity, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        results = [];
                        loadQuantity = limit + offset;
                        //Re-open so we can load 
                        _a = this;
                        return [4 /*yield*/, core_1["default"].orbitDb.open(this.feedStore.address.toString())];
                    case 1:
                        //Re-open so we can load 
                        _a.feedStore = _b.sent();
                        return [4 /*yield*/, this.feedStore.load(loadQuantity)];
                    case 2:
                        _b.sent();
                        return [4 /*yield*/, this.getPosts(limit, olderThan, newerThan)];
                    case 3:
                        results = _b.sent();
                        results.reverse();
                        return [2 /*return*/, results];
                }
            });
        });
    };
    BlogPostService.prototype.getPosts = function (limit, olderThan, newerThan) {
        if (olderThan === void 0) { olderThan = undefined; }
        if (newerThan === void 0) { newerThan = undefined; }
        return __awaiter(this, void 0, void 0, function () {
            var options, results, posts, _i, results_1, cid, _a, _b;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!this.feedStore)
                            return [2 /*return*/, []];
                        options = {
                            limit: limit
                        };
                        if (olderThan) {
                            options.lt = olderThan;
                        }
                        if (newerThan) {
                            options.gt = newerThan;
                        }
                        return [4 /*yield*/, this.feedStore.iterator(options)
                                .collect()
                                .map(function (e) {
                                var permalinkKey = e.payload.value;
                                var cid = _this.kvStore.get(permalinkKey);
                                return cid;
                            })];
                    case 1:
                        results = _c.sent();
                        posts = [];
                        _i = 0, results_1 = results;
                        _c.label = 2;
                    case 2:
                        if (!(_i < results_1.length)) return [3 /*break*/, 5];
                        cid = results_1[_i];
                        if (!cid) return [3 /*break*/, 4];
                        _b = (_a = posts).push;
                        return [4 /*yield*/, BlogPostService.read(cid)];
                    case 3:
                        _b.apply(_a, [_c.sent()]);
                        _c.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/, posts];
                }
            });
        });
    };
    BlogPostService.prototype.create = function (post) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, postCid;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        //Increment counter and set permalink key
                        post.permalinkKey = this._generatePermalink(post);
                        //Store key in the feed
                        _a = post;
                        return [4 /*yield*/, this.feedStore.add(post.permalinkKey)
                            //Store post in IPFS
                        ];
                    case 1:
                        //Store key in the feed
                        _a.feedCid = _b.sent();
                        return [4 /*yield*/, this.store(post)
                            //Associate the postCid with the key
                        ];
                    case 2:
                        postCid = _b.sent();
                        //Associate the postCid with the key
                        return [4 /*yield*/, this.kvStore.put(post.permalinkKey, postCid.toString())];
                    case 3:
                        //Associate the postCid with the key
                        _b.sent();
                        return [2 /*return*/, this.translate(post, postCid)];
                }
            });
        });
    };
    BlogPostService.prototype.update = function (post) {
        return __awaiter(this, void 0, void 0, function () {
            var postCid;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.store(post)];
                    case 1:
                        postCid = _a.sent();
                        return [4 /*yield*/, this.kvStore.put(post.permalinkKey, postCid.toString())];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, this.translate(post, postCid)];
                }
            });
        });
    };
    /**
     * Store post in IPFS. Returns CID.
     * @param post
     */
    BlogPostService.prototype.store = function (post) {
        return __awaiter(this, void 0, void 0, function () {
            var buffer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        buffer = Buffer.from(JSON.stringify(post));
                        return [4 /*yield*/, core_1["default"].ipfs.object.put(buffer)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    BlogPostService.prototype.translate = function (post, postCid) {
        //@ts-ignore
        var returnPost = {};
        Object.assign(returnPost, post);
        returnPost.cid = postCid.toString();
        return returnPost;
    };
    BlogPostService.read = function (cid) {
        return __awaiter(this, void 0, void 0, function () {
            var loaded, data, deserialzied, post;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, core_1["default"].ipfs.object.get(cid)];
                    case 1:
                        loaded = _a.sent();
                        data = loaded.Data ? loaded.Data.toString() : loaded.data.toString();
                        deserialzied = JSON.parse(data);
                        post = {};
                        Object.assign(post, deserialzied);
                        post.cid = cid.toString();
                        return [2 /*return*/, post];
                }
            });
        });
    };
    BlogPostService.prototype.readPermalink = function (permalinkKey) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, BlogPostService.read(this.kvStore.get(permalinkKey))];
            });
        });
    };
    BlogPostService.prototype["delete"] = function (post) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kvStore.del(post.permalinkKey)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.feedStore.remove(post.cid)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BlogPostService.prototype.translatePost = function (post) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.postService.translatePost(post)];
            });
        });
    };
    BlogPostService.prototype._generatePermalink = function (post) {
        return sha256(post.owner + "-" + post.dateCreatedMilli + "-" + post.contentTranslated + "-" + post.title + "-" + post.subtitle);
    };
    BlogPostService.prototype.count = function () {
        return Object.keys(this.kvStore.index).length;
    };
    BlogPostService.prototype.load = function (amount) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.feedStore.load(amount)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BlogPostService.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.feedStore.close()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.kvStore.close()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return BlogPostService;
}());
exports.BlogPostService = BlogPostService;
