import { ReadOnlyPostService } from "./readonly-post-service";
import { Post } from "../dto/post";
import { FriendService } from "./friend-service";
import { Friend } from "../dto/friend";
import { SchemaService } from "./schema-service";
declare class FeedMonitorService {
    private schemaService;
    private friendService;
    private readOnlyPostService;
    private _unreadPosts;
    getUnreadPosts(): number;
    constructor(schemaService: SchemaService, friendService: FriendService, readOnlyPostService: ReadOnlyPostService);
    start(): Promise<void>;
    getFriendsNewPosts(walletAddress: string): Promise<void>;
    getNewPostsFromFriend(friend: Friend): Promise<Post[]>;
    loadUntilCid(store: any, cid: string, limit?: number): Promise<any>;
    saveFriendPosts(posts: Post[], friends: Friend[], walletAddress: string): Promise<void>;
    updateFriendLastPost(friend: Friend, post: Post): Promise<void>;
    markAllPostsRead(): Promise<void>;
}
export { FeedMonitorService };
