"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var core_1 = require("../core");
var FeedMonitorService = /** @class */ (function () {
    function FeedMonitorService(schemaService, friendService, readOnlyPostService) {
        this.schemaService = schemaService;
        this.friendService = friendService;
        this.readOnlyPostService = readOnlyPostService;
        this._unreadPosts = 0;
    }
    FeedMonitorService.prototype.getUnreadPosts = function () {
        return this._unreadPosts;
    };
    FeedMonitorService.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getFriendsNewPosts(window['currentAccount'])];
                    case 1:
                        _a.sent();
                        setInterval(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.getFriendsNewPosts(window['currentAccount'])];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        }); }); }, 60000);
                        return [2 /*return*/];
                }
            });
        });
    };
    FeedMonitorService.prototype.getFriendsNewPosts = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var friends, newPosts, _i, friends_1, friend, friendPosts, ex_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // console.log('start: get new friend posts')
                    return [4 /*yield*/, this.friendService.loadStoreForWallet(walletAddress)];
                    case 1:
                        // console.log('start: get new friend posts')
                        _a.sent();
                        return [4 /*yield*/, this.friendService.getAll()];
                    case 2:
                        friends = _a.sent();
                        newPosts = [];
                        _i = 0, friends_1 = friends;
                        _a.label = 3;
                    case 3:
                        if (!(_i < friends_1.length)) return [3 /*break*/, 8];
                        friend = friends_1[_i];
                        _a.label = 4;
                    case 4:
                        _a.trys.push([4, 6, , 7]);
                        return [4 /*yield*/, this.getNewPostsFromFriend(friend)];
                    case 5:
                        friendPosts = _a.sent();
                        newPosts = newPosts.concat(friendPosts);
                        return [3 /*break*/, 7];
                    case 6:
                        ex_1 = _a.sent();
                        console.log(ex_1);
                        return [3 /*break*/, 7];
                    case 7:
                        _i++;
                        return [3 /*break*/, 3];
                    case 8: return [4 /*yield*/, this.saveFriendPosts(newPosts, friends, walletAddress)
                        // console.log('complete: get new friend posts')
                    ];
                    case 9:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    FeedMonitorService.prototype.getNewPostsFromFriend = function (friend) {
        return __awaiter(this, void 0, void 0, function () {
            var postFeed, posts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!friend.address)
                            return [2 /*return*/];
                        return [4 /*yield*/, this.schemaService.getReadOnlyPostFeedByWalletAddress(friend.address)];
                    case 1:
                        postFeed = _a.sent();
                        return [4 /*yield*/, this.loadUntilCid(postFeed, friend.lastPostFeedCid)];
                    case 2:
                        postFeed = _a.sent();
                        return [4 /*yield*/, postFeed.iterator({
                                limit: -1,
                                gt: friend.lastPostFeedCid
                            })
                                .collect()
                                .map(function (e) {
                                //@ts-ignore
                                var post = {};
                                Object.assign(post, e.payload.value); //don't want to send back a reference to the actual obj in the store
                                post.cid = e.hash;
                                return post;
                            })];
                    case 3:
                        posts = _a.sent();
                        return [2 /*return*/, posts];
                }
            });
        });
    };
    FeedMonitorService.prototype.loadUntilCid = function (store, cid, limit) {
        if (limit === void 0) { limit = 100; }
        return __awaiter(this, void 0, void 0, function () {
            var loopCount, lastPostLoaded_1, previousLoopLength, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!cid) return [3 /*break*/, 3];
                        return [4 /*yield*/, core_1["default"].orbitDb.open(store.address.toString())];
                    case 1:
                        store = _a.sent();
                        return [4 /*yield*/, store.load(limit)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 9];
                    case 3:
                        loopCount = 1;
                        lastPostLoaded_1 = false;
                        previousLoopLength = 0;
                        _a.label = 4;
                    case 4: return [4 /*yield*/, core_1["default"].orbitDb.open(store.address.toString())];
                    case 5:
                        store = _a.sent();
                        return [4 /*yield*/, store.load(loopCount * 5)];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, store.iterator({
                                limit: -1
                            })
                                .collect()
                                .map(function (e) {
                                if (e.hash == cid)
                                    lastPostLoaded_1 = true;
                                return e.hash;
                            })];
                    case 7:
                        results = _a.sent();
                        if (!results || results.length == 0 || results.length >= limit || results.length == previousLoopLength) {
                            lastPostLoaded_1 = true;
                        }
                        previousLoopLength = results.length;
                        loopCount++;
                        _a.label = 8;
                    case 8:
                        if (!lastPostLoaded_1) return [3 /*break*/, 4];
                        _a.label = 9;
                    case 9: return [2 /*return*/, store];
                }
            });
        });
    };
    FeedMonitorService.prototype.saveFriendPosts = function (posts, friends, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var _loop_1, this_1, _i, posts_1, post;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        posts.sort(function (a, b) { return a.dateCreatedMilli > b.dateCreatedMilli ? 1 : -1; });
                        posts = posts.filter(function (post) { return post.owner != undefined; });
                        if (!(posts.length > 0)) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.readOnlyPostService.loadMainFeedForWallet(walletAddress)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.readOnlyPostService.load(1)]; //have to load at least one record or the entire feed gets lost
                    case 2:
                        _a.sent(); //have to load at least one record or the entire feed gets lost
                        _loop_1 = function (post) {
                            var friend;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this_1.readOnlyPostService.create(post)
                                        //Update friend last post seen
                                    ];
                                    case 1:
                                        _a.sent();
                                        friend = friends.find(function (friend) { return friend.address == post.owner; });
                                        return [4 /*yield*/, this_1.updateFriendLastPost(friend, post)
                                            //Increment unread post counter
                                        ];
                                    case 2:
                                        _a.sent();
                                        //Increment unread post counter
                                        this_1._unreadPosts += 1;
                                        core_1["default"].eventEmitter.emit('unread-posts-updated', this_1._unreadPosts);
                                        console.log("Post added: " + post.cid);
                                        return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        _i = 0, posts_1 = posts;
                        _a.label = 3;
                    case 3:
                        if (!(_i < posts_1.length)) return [3 /*break*/, 6];
                        post = posts_1[_i];
                        return [5 /*yield**/, _loop_1(post)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        _i++;
                        return [3 /*break*/, 3];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    FeedMonitorService.prototype.updateFriendLastPost = function (friend, post) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        friend.lastPostFeedCid = post.cid;
                        friend.lastPostMilli = post.dateCreatedMilli;
                        return [4 /*yield*/, this.friendService.put(friend.address, friend)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    FeedMonitorService.prototype.markAllPostsRead = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this._unreadPosts = 0;
                return [2 /*return*/];
            });
        });
    };
    return FeedMonitorService;
}());
exports.FeedMonitorService = FeedMonitorService;
