"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var core_1 = require("../core");
var FriendService = /** @class */ (function () {
    function FriendService(schemaService, profileService) {
        this.schemaService = schemaService;
        this.profileService = profileService;
    }
    FriendService.prototype.setStore = function (store) {
        this.kvStore = store;
    };
    FriendService.prototype.loadStoreForWallet = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var friendStore;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.schemaService.getFriendStoreByWalletAddress(walletAddress)];
                    case 1:
                        friendStore = _a.sent();
                        return [4 /*yield*/, friendStore.load()];
                    case 2:
                        _a.sent();
                        this.setStore(friendStore);
                        return [2 /*return*/];
                }
            });
        });
    };
    FriendService.prototype.connectToFriends = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var friends, _i, friends_1, friend;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('Connecting to friends and updating last known addresses');
                        return [4 /*yield*/, this.loadStoreForWallet(walletAddress)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.getAll()];
                    case 2:
                        friends = _a.sent();
                        for (_i = 0, friends_1 = friends; _i < friends_1.length; _i++) {
                            friend = friends_1[_i];
                            try {
                                this.updateFriendLastKnownAddress(friend);
                                this.connect(friend);
                            }
                            catch (ex) {
                                console.log(ex);
                            }
                        }
                        if (!core_1["default"].isElectron()) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.savePeerList(friends)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    FriendService.prototype.get = function (address) {
        return this.kvStore.get(address.toLowerCase());
    };
    FriendService.prototype.put = function (address, friend) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.kvStore.put(address.toLowerCase(), friend)];
            });
        });
    };
    FriendService.prototype["delete"] = function (address) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.kvStore.del(address)];
            });
        });
    };
    FriendService.prototype.list = function (offset, limit) {
        var _this = this;
        var friends = Object.keys(this.kvStore.index).map(function (key) { return _this.kvStore.index[key]; });
        return friends.slice(offset).slice(0, limit);
    };
    FriendService.prototype.listByDateMilli = function () {
        var friends = this.getAll();
        friends.sort(function (a, b) { return a.lastPostMilli < b.lastPostMilli ? 1 : -1; });
        return friends;
    };
    FriendService.prototype.getAll = function () {
        var _this = this;
        return Object.keys(this.kvStore.index).map(function (key) { return _this.kvStore.index[key]; });
    };
    FriendService.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.kvStore.close()];
            });
        });
    };
    FriendService.prototype.load = function (amount) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.kvStore.load(amount)];
            });
        });
    };
    FriendService.prototype.savePeerList = function (friends) {
        return __awaiter(this, void 0, void 0, function () {
            var peersDao, peerList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        peersDao = window['remote'].getGlobal('peersDao');
                        peerList = friends.map(function (friend) {
                            return friend.lastKnownAddress;
                        });
                        return [4 /*yield*/, peersDao.savePeers(peerList)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    FriendService.prototype.updateFriendLastKnownAddress = function (friend) {
        return __awaiter(this, void 0, void 0, function () {
            var friendProfile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.profileService.getProfileByWallet(friend.address)];
                    case 1:
                        friendProfile = _a.sent();
                        if (!friendProfile) return [3 /*break*/, 3];
                        friend.lastKnownAddress = friendProfile.lastKnownAddress;
                        return [4 /*yield*/, this.put(friend.address, friend)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    FriendService.prototype.connect = function (friend) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, address, ex_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(friend.lastKnownAddress && friend.lastKnownAddress.length > 0)) return [3 /*break*/, 6];
                        _i = 0, _a = friend.lastKnownAddress;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 6];
                        address = _a[_i];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 4, , 5]);
                        console.log("Peering with last known address: " + address);
                        return [4 /*yield*/, core_1["default"].ipfs.swarm.connect(address)];
                    case 3:
                        _b.sent();
                        return [3 /*break*/, 6];
                    case 4:
                        ex_1 = _b.sent();
                        return [3 /*break*/, 5];
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    return FriendService;
}());
exports.FriendService = FriendService;
