import { SchemaService } from "./schema-service";
import { Page } from "../dto/page";
import { PostService } from "./post-service";
declare class PageService {
    private schemaService;
    private postService;
    loadedWalletAddress: string;
    kvStore: any;
    constructor(schemaService: SchemaService, postService: PostService);
    loadStoresForWallet(walletAddress: string): Promise<void>;
    getPages(): Promise<Page[]>;
    create(page: Page): Promise<Page>;
    update(page: Page): Promise<Page>;
    static read(cid: string): Promise<Page>;
    readPermalink(permalinkKey: string): Promise<Page>;
    delete(page: Page): Promise<void>;
    translatePage(page: Page): Promise<Page>;
    private _generatePermalink;
    /**
     * Store post in IPFS. Returns CID.
     * @param post
     */
    private store;
    private translate;
    close(): Promise<void>;
}
export { PageService };
