"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var core_1 = require("../core");
var sha256 = require('js-sha256');
var moment = require('moment');
var PageService = /** @class */ (function () {
    function PageService(schemaService, postService) {
        this.schemaService = schemaService;
        this.postService = postService;
    }
    PageService.prototype.loadStoresForWallet = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (walletAddress == this.loadedWalletAddress)
                            return [2 /*return*/];
                        _a = this;
                        return [4 /*yield*/, this.schemaService.getPageKvStoreByWalletAddress(walletAddress)];
                    case 1:
                        _a.kvStore = _b.sent();
                        return [4 /*yield*/, this.kvStore.load()];
                    case 2:
                        _b.sent();
                        this.loadedWalletAddress = walletAddress;
                        return [2 /*return*/];
                }
            });
        });
    };
    PageService.prototype.getPages = function () {
        return __awaiter(this, void 0, void 0, function () {
            var pages, keys, _i, keys_1, key, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        pages = [];
                        keys = Object.keys(this.kvStore.index);
                        _i = 0, keys_1 = keys;
                        _c.label = 1;
                    case 1:
                        if (!(_i < keys_1.length)) return [3 /*break*/, 4];
                        key = keys_1[_i];
                        _b = (_a = pages).push;
                        return [4 /*yield*/, PageService.read(this.kvStore.get(key))];
                    case 2:
                        _b.apply(_a, [_c.sent()]);
                        _c.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, pages];
                }
            });
        });
    };
    PageService.prototype.create = function (page) {
        return __awaiter(this, void 0, void 0, function () {
            var pageCid;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        //Increment counter and set permalink key
                        page.permalinkKey = this._generatePermalink(page);
                        return [4 /*yield*/, this.store(page)
                            //Associate the postCid with the key
                        ];
                    case 1:
                        pageCid = _a.sent();
                        //Associate the postCid with the key
                        return [4 /*yield*/, this.kvStore.put(page.permalinkKey, pageCid.toString())];
                    case 2:
                        //Associate the postCid with the key
                        _a.sent();
                        return [2 /*return*/, this.translate(page, pageCid)];
                }
            });
        });
    };
    PageService.prototype.update = function (page) {
        return __awaiter(this, void 0, void 0, function () {
            var pageCid;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.store(page)];
                    case 1:
                        pageCid = _a.sent();
                        return [4 /*yield*/, this.kvStore.put(page.permalinkKey, pageCid.toString())];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, this.translate(page, pageCid)];
                }
            });
        });
    };
    PageService.read = function (cid) {
        return __awaiter(this, void 0, void 0, function () {
            var loaded, data, deserialzied, page;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, core_1["default"].ipfs.object.get(cid)];
                    case 1:
                        loaded = _a.sent();
                        data = loaded.Data ? loaded.Data.toString() : loaded.data.toString();
                        deserialzied = JSON.parse(data);
                        page = {};
                        Object.assign(page, deserialzied);
                        page.cid = cid.toString();
                        return [2 /*return*/, page];
                }
            });
        });
    };
    PageService.prototype.readPermalink = function (permalinkKey) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, PageService.read(this.kvStore.get(permalinkKey))];
            });
        });
    };
    PageService.prototype["delete"] = function (page) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kvStore.del(page.permalinkKey)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PageService.prototype.translatePage = function (page) {
        return __awaiter(this, void 0, void 0, function () {
            var translated, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        translated = {};
                        Object.assign(translated, page);
                        _a = translated;
                        return [4 /*yield*/, this.postService.translateContent(page)
                            //@ts-ignore //TODO: fix this somehow later. view model
                        ];
                    case 1:
                        _a.contentTranslated = _b.sent();
                        //@ts-ignore //TODO: fix this somehow later. view model
                        translated.dateCreatedDisplay = moment(page.dateCreatedMilli).fromNow();
                        return [2 /*return*/, translated];
                }
            });
        });
    };
    PageService.prototype._generatePermalink = function (page) {
        return sha256(page.owner + "-" + page.dateCreatedMilli + "-" + page.contentTranslated + "-" + page.title);
    };
    /**
     * Store post in IPFS. Returns CID.
     * @param post
     */
    PageService.prototype.store = function (page) {
        return __awaiter(this, void 0, void 0, function () {
            var buffer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        buffer = Buffer.from(JSON.stringify(page));
                        return [4 /*yield*/, core_1["default"].ipfs.object.put(buffer)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    PageService.prototype.translate = function (page, pageCid) {
        //@ts-ignore
        var returnPage = {};
        Object.assign(returnPage, page);
        returnPage.cid = pageCid.toString();
        return returnPage;
    };
    PageService.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kvStore.close()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return PageService;
}());
exports.PageService = PageService;
