"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var quill_delta_to_html_1 = require("quill-delta-to-html");
var moment = require('moment');
var PostService = /** @class */ (function () {
    function PostService(schemaService, imageService, profileService) {
        this.schemaService = schemaService;
        this.imageService = imageService;
        this.profileService = profileService;
    }
    PostService.prototype.buildPost = function (walletAddress, content, parent) {
        if (parent === void 0) { parent = undefined; }
        return __awaiter(this, void 0, void 0, function () {
            var profile, ex_1, post, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.profileService.getProfileByWallet(walletAddress)];
                    case 1:
                        profile = _e.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        ex_1 = _e.sent();
                        console.log(ex_1);
                        return [3 /*break*/, 3];
                    case 3:
                        post = {
                            owner: walletAddress,
                            ownerDisplayName: (profile && profile.name) ? profile.name : walletAddress,
                            dateCreatedMilli: moment().utc().valueOf(),
                            content: content
                        };
                        if (parent) {
                            post.parentCid = parent.cid;
                        }
                        _a = post;
                        _c = (_b = this.schemaService).getRepliesPostFeedAddress;
                        _d = [post];
                        return [4 /*yield*/, this.translateContent(post)];
                    case 4: return [4 /*yield*/, _c.apply(_b, _d.concat([_e.sent()]))];
                    case 5:
                        _a.replies = _e.sent();
                        //Set user avatar
                        if (profile && profile.profilePic) {
                            post.ownerProfilePic = profile.profilePic;
                        }
                        return [2 /*return*/, post];
                }
            });
        });
    };
    PostService.prototype.translatePost = function (post) {
        return __awaiter(this, void 0, void 0, function () {
            var translated, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        translated = {};
                        Object.assign(translated, post);
                        _a = translated;
                        return [4 /*yield*/, this.translateContent(post)
                            //@ts-ignore //TODO: fix this somehow later. view model
                        ];
                    case 1:
                        _a.contentTranslated = _c.sent();
                        //@ts-ignore //TODO: fix this somehow later. view model
                        translated.dateCreatedDisplay = moment(post.dateCreatedMilli).fromNow();
                        if (!translated.ownerProfilePic) return [3 /*break*/, 3];
                        _b = translated;
                        return [4 /*yield*/, this.imageService.cidToUrl(post.ownerProfilePic)];
                    case 2:
                        _b.ownerProfilePicSrc = _c.sent();
                        _c.label = 3;
                    case 3: return [2 /*return*/, translated];
                }
            });
        });
    };
    PostService.prototype.translateContent = function (post) {
        return __awaiter(this, void 0, void 0, function () {
            var imageUrls, _i, _a, op, cid, _b, _c, qdc;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (!post.content)
                            return [2 /*return*/];
                        imageUrls = {};
                        _i = 0, _a = post.content.ops;
                        _d.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 4];
                        op = _a[_i];
                        if (!op.insert.ipfsimage) return [3 /*break*/, 3];
                        cid = op.insert.ipfsimage.ipfsCid;
                        _b = imageUrls;
                        _c = cid;
                        return [4 /*yield*/, this.imageService.cidToUrl(cid)];
                    case 2:
                        _b[_c] = _d.sent();
                        _d.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4:
                        qdc = new quill_delta_to_html_1.QuillDeltaToHtmlConverter(post.content.ops, {});
                        //Render dividers into HTML
                        qdc.renderCustomWith(function (customOp, contextOp) {
                            if (customOp.insert.type === 'divider') {
                                return "<hr />";
                            }
                            if (customOp.insert.type === 'ipfsimage') {
                                return "<img class=\"blob-image\" src=\"" + imageUrls[customOp.insert.value.ipfsCid] + "\" width=\"" + customOp.insert.value.width + "\" height=\"" + customOp.insert.value.height + "\" style=\"" + customOp.insert.value.style + "\"  />";
                            }
                        });
                        return [2 /*return*/, qdc.convert()];
                }
            });
        });
    };
    return PostService;
}());
exports.PostService = PostService;
