import { PostService } from "./post-service";
import { FriendService } from "./friend-service";
import { Friend } from "../dto/friend";
import { SchemaService } from "./schema-service";
import { ProfileService } from "./profile-service";
declare class ProcessFeedService {
    private friendService;
    private schemaService;
    private profileService;
    private postService;
    private _started;
    private _unreadPosts;
    private _monitoredFeeds;
    getUnreadPosts(): number;
    constructor(friendService: FriendService, schemaService: SchemaService, profileService: ProfileService, postService: PostService);
    start(): Promise<void>;
    postAdded(postCid: any): Promise<void>;
    monitorPostFeed(postFeed: any): Promise<void>;
    monitorChildFeed(postFeed: any): Promise<void>;
    addPostFeedReplicatedListener(postFeed: any): void;
    addChildFeedReplicateProgressListener(childFeed: any): void;
    isMonitored(postFeed: any): boolean;
    loadFriendFeeds(walletAddress: string): Promise<void>;
    peer(friend: Friend): Promise<void>;
    monitorFriendFeed(friend: Friend): Promise<void>;
    updateFriendLastKnownAddress(friend: Friend): Promise<void>;
    connectToFriend(friend: Friend): Promise<void>;
    markAllPostsRead(): Promise<void>;
    savePeerList(friends: Friend[]): Promise<void>;
}
export { ProcessFeedService };
