"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var post_service_1 = require("./post-service");
var core_1 = require("../core");
var OrbitDB = require('orbit-db');
var OrbitDBAddress = require('orbit-db/src/orbit-db-address.js');
var Pubsub = require('orbit-db-pubsub');
var ProcessFeedService = /** @class */ (function () {
    function ProcessFeedService(friendService, schemaService, profileService, postService) {
        this.friendService = friendService;
        this.schemaService = schemaService;
        this.profileService = profileService;
        this.postService = postService;
        this._started = false;
        this._unreadPosts = 0;
        this._monitoredFeeds = [];
        this.start();
    }
    ProcessFeedService.prototype.getUnreadPosts = function () {
        return this._unreadPosts;
    };
    ProcessFeedService.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            var self;
            return __generator(this, function (_a) {
                self = this;
                if (this._started)
                    return [2 /*return*/];
                core_1["default"].eventEmitter.on("post-added", function (address, hash, entry) {
                    return __awaiter(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, self.postAdded(entry.payload.value)];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    });
                });
                this.loadFriendFeeds(window['currentAccount']);
                this._started = true;
                return [2 /*return*/];
            });
        });
    };
    ProcessFeedService.prototype.postAdded = function (postCid) {
        return __awaiter(this, void 0, void 0, function () {
            var post;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, post_service_1.PostService.read(postCid)];
                    case 1:
                        post = _a.sent();
                        return [4 /*yield*/, this.postService.loadMainFeedForWallet(window['currentAccount'])];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.postService.create(post)];
                    case 3:
                        _a.sent();
                        this._unreadPosts += 1;
                        core_1["default"].eventEmitter.emit('updated-unread-posts', this._unreadPosts);
                        console.log("Post added: " + postCid);
                        return [2 /*return*/];
                }
            });
        });
    };
    ProcessFeedService.prototype.monitorPostFeed = function (postFeed) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.isMonitored(postFeed)) {
                    console.log("Feed is already being monitored");
                    return [2 /*return*/];
                }
                this.addPostFeedReplicatedListener(postFeed);
                this.monitorChildFeed(postFeed);
                console.log("Monitoring post feed: " + postFeed.address);
                this._monitoredFeeds.push(new MonitoredFeed(postFeed, true));
                return [2 /*return*/];
            });
        });
    };
    ProcessFeedService.prototype.monitorChildFeed = function (postFeed) {
        return __awaiter(this, void 0, void 0, function () {
            var feedInfo, childFeedAddress, childFeed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.postService.getFeedInfo(postFeed)];
                    case 1:
                        feedInfo = _a.sent();
                        if (!feedInfo) {
                            console.log('No child feed found to monitor');
                            return [2 /*return*/];
                        }
                        childFeedAddress = new OrbitDBAddress(feedInfo.feedAddress.root, feedInfo.feedAddress.path).toString();
                        return [4 /*yield*/, this.schemaService.openStore(childFeedAddress)];
                    case 2:
                        childFeed = _a.sent();
                        return [4 /*yield*/, childFeed.load()]; //await here?
                    case 3:
                        _a.sent(); //await here?
                        this.addChildFeedReplicateProgressListener(childFeed);
                        if (!this.isMonitored(childFeed)) {
                            console.log("Monitoring child feed: " + childFeed.address);
                            this._monitoredFeeds.push(new MonitoredFeed(childFeed, false));
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    ProcessFeedService.prototype.addPostFeedReplicatedListener = function (postFeed) {
        var _this = this;
        postFeed.events.on("replicated", function () {
            console.log('Finished replicating primary post feed');
            _this.monitorChildFeed(postFeed);
        });
    };
    ProcessFeedService.prototype.addChildFeedReplicateProgressListener = function (childFeed) {
        childFeed.events.on("replicate.progress", function (address, hash, entry, progress, max) {
            console.log('Child feed replicate progress');
            core_1["default"].eventEmitter.emit("post-added", address, hash, entry);
        });
    };
    ProcessFeedService.prototype.isMonitored = function (postFeed) {
        var existingMonitor = this._monitoredFeeds.filter(function (e) {
            return e.feed.address.toString() == postFeed.address.toString();
        });
        var isMonitored = (existingMonitor.length > 0);
        return isMonitored;
    };
    ProcessFeedService.prototype.loadFriendFeeds = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var friends, _i, friends_1, friend, ex_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('Opening friend posts feeds');
                        return [4 /*yield*/, this.friendService.loadStoreForWallet(walletAddress)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.friendService.getAll()];
                    case 2:
                        friends = _a.sent();
                        _i = 0, friends_1 = friends;
                        _a.label = 3;
                    case 3:
                        if (!(_i < friends_1.length)) return [3 /*break*/, 8];
                        friend = friends_1[_i];
                        _a.label = 4;
                    case 4:
                        _a.trys.push([4, 6, , 7]);
                        return [4 /*yield*/, this.peer(friend)];
                    case 5:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 6:
                        ex_1 = _a.sent();
                        console.log(ex_1);
                        return [3 /*break*/, 7];
                    case 7:
                        _i++;
                        return [3 /*break*/, 3];
                    case 8:
                        if (!core_1["default"].isElectron) return [3 /*break*/, 10];
                        return [4 /*yield*/, this.savePeerList(friends)];
                    case 9:
                        _a.sent();
                        _a.label = 10;
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
    ProcessFeedService.prototype.peer = function (friend) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.monitorFriendFeed(friend);
                this.updateFriendLastKnownAddress(friend);
                this.connectToFriend(friend);
                return [2 /*return*/];
            });
        });
    };
    ProcessFeedService.prototype.monitorFriendFeed = function (friend) {
        return __awaiter(this, void 0, void 0, function () {
            var postFeed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.schemaService.getPostFeedByWalletAddress(friend.address)];
                    case 1:
                        postFeed = _a.sent();
                        this.monitorPostFeed(postFeed);
                        return [2 /*return*/];
                }
            });
        });
    };
    ProcessFeedService.prototype.updateFriendLastKnownAddress = function (friend) {
        return __awaiter(this, void 0, void 0, function () {
            var friendProfile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.profileService.getProfileByWallet(friend.address)];
                    case 1:
                        friendProfile = _a.sent();
                        if (friendProfile) {
                            // console.log(`Updating last known address: ${friendProfile._id}`)
                            friend.lastKnownAddress = friendProfile.lastKnownAddress;
                            this.friendService.put(friend);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    ProcessFeedService.prototype.connectToFriend = function (friend) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, address, ex_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(friend.lastKnownAddress && friend.lastKnownAddress.length > 0)) return [3 /*break*/, 6];
                        _i = 0, _a = friend.lastKnownAddress;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 6];
                        address = _a[_i];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 4, , 5]);
                        console.log("Peering with last known address: " + address);
                        return [4 /*yield*/, core_1["default"].ipfs.swarm.connect(address)];
                    case 3:
                        _b.sent();
                        return [3 /*break*/, 6];
                    case 4:
                        ex_2 = _b.sent();
                        console.log(ex_2);
                        return [3 /*break*/, 5];
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ProcessFeedService.prototype.markAllPostsRead = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this._unreadPosts = 0;
                return [2 /*return*/];
            });
        });
    };
    ProcessFeedService.prototype.savePeerList = function (friends) {
        return __awaiter(this, void 0, void 0, function () {
            var peersDao, peerList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        peersDao = window['remote'].getGlobal('peersDao');
                        peerList = friends.map(function (friend) {
                            return friend.lastKnownAddress;
                        });
                        return [4 /*yield*/, peersDao.savePeers(peerList)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return ProcessFeedService;
}());
exports.ProcessFeedService = ProcessFeedService;
var MonitoredFeed = /** @class */ (function () {
    function MonitoredFeed(feed, isParent) {
        this.feed = feed;
        this.isParent = isParent;
    }
    return MonitoredFeed;
}());
