"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var profile_1 = require("../dto/profile");
var timeout_promise_1 = require("../timeout-promise");
var core_1 = require("../core");
var ProfileService = /** @class */ (function () {
    function ProfileService(schemaService) {
        this.schemaService = schemaService;
    }
    ProfileService.prototype.setStore = function (store) {
        this.store = store;
    };
    ProfileService.prototype.getCurrentUser = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.getProfileByWallet(window['currentAccount'])];
            });
        });
    };
    ProfileService.prototype.getProfileByWallet = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var profile;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loadStoreForWallet(walletAddress)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.store.load()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.read(walletAddress)];
                    case 3:
                        profile = _a.sent();
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                if (profile) {
                                    resolve(profile);
                                }
                                //If it's us don't bother waiting
                                if (walletAddress == window['currentAccount']) {
                                    resolve();
                                }
                                _this.store.events.on('replicated', function () { return __awaiter(_this, void 0, void 0, function () {
                                    var profile;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                console.log("Replicated profile for " + walletAddress);
                                                return [4 /*yield*/, this.read(walletAddress)];
                                            case 1:
                                                profile = _a.sent();
                                                resolve(profile);
                                                return [2 /*return*/];
                                        }
                                    });
                                }); });
                            })];
                }
            });
        });
    };
    ProfileService.prototype.updateLastKnownAddress = function () {
        return __awaiter(this, void 0, void 0, function () {
            var currentUser, id;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getCurrentUser()];
                    case 1:
                        currentUser = _a.sent();
                        if (!currentUser) return [3 /*break*/, 4];
                        return [4 /*yield*/, core_1["default"].ipfs.id()];
                    case 2:
                        id = _a.sent();
                        currentUser.lastKnownAddress = id.addresses;
                        return [4 /*yield*/, this.put(currentUser)];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        console.log('No profile found. Unable to update last known address');
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    // @timeout(2000)
    ProfileService.prototype.loadStoreForWallet = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var profileStore;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.schemaService.getProfileStoreByWalletAddress(walletAddress)];
                    case 1:
                        profileStore = _a.sent();
                        this.setStore(profileStore);
                        return [2 /*return*/];
                }
            });
        });
    };
    ProfileService.prototype.read = function (address) {
        return __awaiter(this, void 0, void 0, function () {
            var profile, e;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        profile = new profile_1.Profile();
                        return [4 /*yield*/, this.store.get(address)];
                    case 1:
                        e = _a.sent();
                        if (e && e.length > 0) {
                            Object.assign(profile, e[0]);
                            return [2 /*return*/, profile];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    ProfileService.prototype.put = function (profile) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.store.put(profile)];
            });
        });
    };
    ProfileService.prototype["delete"] = function (cid) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.store.del(cid)];
            });
        });
    };
    ProfileService.prototype.load = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.store.load()];
            });
        });
    };
    __decorate([
        timeout_promise_1.timeout(2000)
    ], ProfileService.prototype, "getProfileByWallet");
    __decorate([
        timeout_promise_1.timeout(2000)
    ], ProfileService.prototype, "load");
    return ProfileService;
}());
exports.ProfileService = ProfileService;
