import { Post } from "../dto/post";
import { SchemaService } from "./schema-service";
import { PostService } from "./post-service";
declare class ReadOnlyPostService {
    private schemaService;
    private postService;
    setFeed(feed: any): void;
    feedStore: any;
    constructor(schemaService: SchemaService, postService: PostService);
    loadPostFeedForWallet(walletAddress: string): Promise<void>;
    loadMainFeedForWallet(walletAddress: string): Promise<void>;
    loadRepliesFeed(feedAddress: string): Promise<void>;
    getRecentPosts(offset: number, limit: number, olderThan?: string, newerThan?: string): Promise<Post[]>;
    getPosts(limit: number, olderThan?: string, newerThan?: string): Promise<any>;
    create(post: Post): Promise<Post>;
    static read(cid: string): Promise<Post>;
    delete(post: Post): Promise<void>;
    countFeedStore(): number;
    countLoaded(store: any): number;
    postMessage(content: any, walletAddress: string): Promise<Post>;
    postReply(parent: Post, content: any, walletAddress: string): Promise<Post>;
    translatePost(post: Post): Promise<Post>;
    load(amount: any): Promise<any>;
    close(): Promise<any>;
}
export { ReadOnlyPostService };
