"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var core_1 = require("../core");
var OrbitDBAddress = require('orbit-db/src/orbit-db-address.js');
var ReadOnlyPostService = /** @class */ (function () {
    function ReadOnlyPostService(schemaService, postService) {
        this.schemaService = schemaService;
        this.postService = postService;
    }
    ReadOnlyPostService.prototype.setFeed = function (feed) {
        this.feedStore = feed;
    };
    ReadOnlyPostService.prototype.loadPostFeedForWallet = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var postFeed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.schemaService.getReadOnlyPostFeedByWalletAddress(walletAddress)];
                    case 1:
                        postFeed = _a.sent();
                        this.feedStore = postFeed;
                        return [2 /*return*/];
                }
            });
        });
    };
    ReadOnlyPostService.prototype.loadMainFeedForWallet = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var mainFeed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.schemaService.getMainFeedByWalletAddress(walletAddress)];
                    case 1:
                        mainFeed = _a.sent();
                        this.feedStore = mainFeed;
                        return [2 /*return*/];
                }
            });
        });
    };
    ReadOnlyPostService.prototype.loadRepliesFeed = function (feedAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var repliesFeed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, core_1["default"].orbitDb.open(feedAddress)];
                    case 1:
                        repliesFeed = _a.sent();
                        this.feedStore = repliesFeed;
                        return [2 /*return*/];
                }
            });
        });
    };
    ReadOnlyPostService.prototype.getRecentPosts = function (offset, limit, olderThan, newerThan) {
        if (olderThan === void 0) { olderThan = undefined; }
        if (newerThan === void 0) { newerThan = undefined; }
        return __awaiter(this, void 0, void 0, function () {
            var results, loadQuantity;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        results = [];
                        loadQuantity = limit + offset;
                        return [4 /*yield*/, this.feedStore.load(loadQuantity)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.getPosts(limit, olderThan, newerThan)];
                    case 2:
                        results = _a.sent();
                        results.reverse();
                        return [2 /*return*/, results];
                }
            });
        });
    };
    ReadOnlyPostService.prototype.getPosts = function (limit, olderThan, newerThan) {
        if (olderThan === void 0) { olderThan = undefined; }
        if (newerThan === void 0) { newerThan = undefined; }
        return __awaiter(this, void 0, void 0, function () {
            var options, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.feedStore)
                            return [2 /*return*/, []];
                        options = {
                            limit: limit
                        };
                        if (olderThan) {
                            options.lt = olderThan;
                        }
                        if (newerThan) {
                            options.gt = newerThan;
                        }
                        return [4 /*yield*/, this.feedStore.iterator(options)
                                .collect()
                                .map(function (e) {
                                //@ts-ignore
                                var post = {};
                                Object.assign(post, e.payload.value); //don't want to send back a reference to the actual obj in the store
                                post.cid = e.hash;
                                return post;
                            })];
                    case 1:
                        results = _a.sent();
                        return [2 /*return*/, results];
                }
            });
        });
    };
    ReadOnlyPostService.prototype.create = function (post) {
        return __awaiter(this, void 0, void 0, function () {
            var feedCid, returnPost;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.feedStore.add(post)
                        //@ts-ignore
                    ];
                    case 1:
                        feedCid = _a.sent();
                        returnPost = {};
                        Object.assign(returnPost, post);
                        returnPost.cid = feedCid;
                        return [2 /*return*/, returnPost];
                }
            });
        });
    };
    ReadOnlyPostService.read = function (cid) {
        return __awaiter(this, void 0, void 0, function () {
            var loaded, post;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, core_1["default"].ipfs.object.get(cid)
                        //@ts-ignore
                    ];
                    case 1:
                        loaded = _a.sent();
                        post = {};
                        Object.assign(post, loaded.payload.value);
                        post.cid = cid.toString();
                        return [2 /*return*/, post];
                }
            });
        });
    };
    ReadOnlyPostService.prototype["delete"] = function (post) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.feedStore.remove(post.cid)];
            });
        });
    };
    ReadOnlyPostService.prototype.countFeedStore = function () {
        return this.countLoaded(this.feedStore);
    };
    ReadOnlyPostService.prototype.countLoaded = function (store) {
        if (!store || !store._index)
            return 0;
        return Object.keys(store._index._index).length;
    };
    ReadOnlyPostService.prototype.postMessage = function (content, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var post;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.postService.buildPost(walletAddress, content)];
                    case 1:
                        post = _a.sent();
                        //Load user's post feed
                        return [4 /*yield*/, this.loadPostFeedForWallet(walletAddress)];
                    case 2:
                        //Load user's post feed
                        _a.sent();
                        return [4 /*yield*/, this.load(1)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.create(post)
                            //Put in user's main feed too
                        ];
                    case 4:
                        _a.sent();
                        //Put in user's main feed too
                        return [4 /*yield*/, this.loadMainFeedForWallet(walletAddress)];
                    case 5:
                        //Put in user's main feed too
                        _a.sent();
                        return [4 /*yield*/, this.load(1)];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, this.create(post)];
                    case 7:
                        _a.sent();
                        return [4 /*yield*/, this.postService.translatePost(post)];
                    case 8:
                        _a.sent();
                        return [2 /*return*/, post];
                }
            });
        });
    };
    ReadOnlyPostService.prototype.postReply = function (parent, content, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var post;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.postService.buildPost(walletAddress, content, parent)];
                    case 1:
                        post = _a.sent();
                        //Load replies feed
                        return [4 /*yield*/, this.loadRepliesFeed(parent.replies)];
                    case 2:
                        //Load replies feed
                        _a.sent();
                        return [4 /*yield*/, this.create(post)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.postService.translatePost(post)];
                    case 4:
                        _a.sent();
                        return [2 /*return*/, post];
                }
            });
        });
    };
    ReadOnlyPostService.prototype.translatePost = function (post) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.postService.translatePost(post)];
            });
        });
    };
    ReadOnlyPostService.prototype.load = function (amount) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.feedStore.load(amount)];
            });
        });
    };
    ReadOnlyPostService.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.feedStore.close()];
            });
        });
    };
    return ReadOnlyPostService;
}());
exports.ReadOnlyPostService = ReadOnlyPostService;
