import { Schema } from "../dto/schema";
import { Post } from "../dto/post";
declare class SchemaService {
    private _cachedSchemas;
    constructor();
    getSchema(store: any, walletAddress: string): Promise<Schema>;
    getSchemaByWalletAddress(walletAddress: string): Promise<Schema>;
    getMainStoreByWalletAddress(walletAddress: string): Promise<any>;
    getMainFeedByWalletAddress(walletAddress: string): Promise<any>;
    getProfileStoreByWalletAddress(walletAddress: string): Promise<any>;
    getReadOnlyPostFeedByWalletAddress(walletAddress: string): Promise<any>;
    getBlogPostFeedByWalletAddress(walletAddress: string): Promise<any>;
    getBlogPostKvStoreByWalletAddress(walletAddress: string): Promise<any>;
    getPageKvStoreByWalletAddress(walletAddress: string): Promise<any>;
    getFriendStoreByWalletAddress(walletAddress: string): Promise<any>;
    getSiteSettingsStoreByWalletAddress(walletAddress: string): Promise<any>;
    reopenStore(store: any): Promise<any>;
    dropStore(address: string): Promise<void>;
    getRepliesPostFeed(post: Post, translatedContent: string): Promise<any>;
    getRepliesPostFeedAddress(post: Post, translatedContent: string): Promise<string>;
    getOrbitAddress(orbitCid: string, walletAddress: string): string;
    private _getMainStoreNameSeed;
    private _getMainFeedNameSeed;
    private _getProfileStoreNameSeed;
    private _getReadOnlyPostFeedNameSeed;
    private _getBlogPostFeedNameSeed;
    private _getBlogPostKvStoreNameSeed;
    private _getPageKvStoreNameSeed;
    private _getFriendStoreNameSeed;
    private _getSiteSettingsStoreNameSeed;
    private _getRepliesFeedNameSeed;
    generateMainStore(orbit: any, accessController: any, walletAddress: string): Promise<any>;
    generateSchema(orbitdb: any, accessController: any, mainStore: any, walletAddress: string): Promise<void>;
    updateSchema(mainStore: any, schema: Schema, walletAddress: string): Promise<void>;
    generateMainFeed(orbitdb: any, accessController: any, walletAddress: string): Promise<any>;
    generateProfileStore(orbitdb: any, accessController: any, walletAddress: string): Promise<any>;
    generateReadOnlyPostFeed(orbitdb: any, accessController: any, walletAddress: string): Promise<any>;
    generateBlogPostFeed(orbitdb: any, accessController: any, walletAddress: string): Promise<any>;
    generateBlogPostKvStore(orbitdb: any, accessController: any, walletAddress: string): Promise<any>;
    generatePageKvStore(orbitdb: any, accessController: any, walletAddress: string): Promise<any>;
    generateFriendStore(orbitdb: any, accessController: any, walletAddress: string): Promise<any>;
    generateSiteSettingsStore(orbitdb: any, accessController: any, walletAddress: string): Promise<any>;
    openAddress(address: any): Promise<any>;
}
export { SchemaService };
