"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var core_1 = require("../core");
var OrbitDB = require('orbit-db');
var OrbitDBAddress = require('orbit-db/src/orbit-db-address.js');
var sha256 = require('js-sha256');
var SchemaService = /** @class */ (function () {
    function SchemaService() {
        this._cachedSchemas = {};
    }
    SchemaService.prototype.getSchema = function (store, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var schema, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, store.get(walletAddress)];
                    case 1:
                        results = _a.sent();
                        if (results && results[0] && results[0].value) {
                            schema = results[0].value;
                        }
                        return [2 /*return*/, schema];
                }
            });
        });
    };
    SchemaService.prototype.getSchemaByWalletAddress = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var cached, mainStore, schema;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cached = this._cachedSchemas[walletAddress];
                        if (cached)
                            return [2 /*return*/, cached];
                        return [4 /*yield*/, this.getMainStoreByWalletAddress(walletAddress)];
                    case 1:
                        mainStore = _a.sent();
                        return [4 /*yield*/, this.getSchema(mainStore, walletAddress)
                            //Cache it
                        ];
                    case 2:
                        schema = _a.sent();
                        //Cache it
                        this._cachedSchemas[walletAddress] = schema;
                        if (schema)
                            return [2 /*return*/, schema];
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                mainStore.events.on('replicated', function () { return __awaiter(_this, void 0, void 0, function () {
                                    var schema;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                console.log("Replicated main store for " + walletAddress);
                                                return [4 /*yield*/, this.getSchema(mainStore, walletAddress)
                                                    //Cache it
                                                ];
                                            case 1:
                                                schema = _a.sent();
                                                //Cache it
                                                this._cachedSchemas[walletAddress] = schema;
                                                resolve(schema);
                                                return [2 /*return*/];
                                        }
                                    });
                                }); });
                            })
                            // throw new Error(`Schema for wallet ${walletAddress} could not be found`)
                        ];
                }
            });
        });
    };
    SchemaService.prototype.getMainStoreByWalletAddress = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var mainStore, mainStoreName, mainStoreAddress;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mainStoreName = this._getMainStoreNameSeed(walletAddress);
                        return [4 /*yield*/, core_1["default"].orbitDb.determineAddress(mainStoreName, 'docstore', {
                                accessController: core_1["default"].orbitAccessControl //This might cause issues in the future. Do we need to
                            })
                            //Try to open it
                        ];
                    case 1:
                        mainStoreAddress = _a.sent();
                        return [4 /*yield*/, core_1["default"].orbitDb.open(mainStoreAddress, {
                                fetchEntryTimeout: 5000
                            })];
                    case 2:
                        //Try to open it
                        mainStore = _a.sent();
                        return [4 /*yield*/, mainStore.load()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, mainStore];
                }
            });
        });
    };
    SchemaService.prototype.getMainFeedByWalletAddress = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getSchemaByWalletAddress(walletAddress)];
                    case 1:
                        schema = _a.sent();
                        return [2 /*return*/, core_1["default"].orbitDb.open(schema.mainFeed, {
                                fetchEntryTimeout: 5000
                            })];
                }
            });
        });
    };
    SchemaService.prototype.getProfileStoreByWalletAddress = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getSchemaByWalletAddress(walletAddress)];
                    case 1:
                        schema = _a.sent();
                        return [2 /*return*/, core_1["default"].orbitDb.open(schema.profileStore, {
                                fetchEntryTimeout: 5000
                            })];
                }
            });
        });
    };
    SchemaService.prototype.getReadOnlyPostFeedByWalletAddress = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getSchemaByWalletAddress(walletAddress)];
                    case 1:
                        schema = _a.sent();
                        return [2 /*return*/, core_1["default"].orbitDb.open(schema.readOnlyPostFeed, {
                                fetchEntryTimeout: 5000
                            })];
                }
            });
        });
    };
    SchemaService.prototype.getBlogPostFeedByWalletAddress = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getSchemaByWalletAddress(walletAddress)];
                    case 1:
                        schema = _a.sent();
                        return [2 /*return*/, core_1["default"].orbitDb.open(schema.blogPostFeed, {
                                fetchEntryTimeout: 5000
                            })];
                }
            });
        });
    };
    SchemaService.prototype.getBlogPostKvStoreByWalletAddress = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getSchemaByWalletAddress(walletAddress)];
                    case 1:
                        schema = _a.sent();
                        return [2 /*return*/, core_1["default"].orbitDb.open(schema.blogPostKvStore, {
                                fetchEntryTimeout: 5000
                            })];
                }
            });
        });
    };
    SchemaService.prototype.getPageKvStoreByWalletAddress = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getSchemaByWalletAddress(walletAddress)];
                    case 1:
                        schema = _a.sent();
                        return [2 /*return*/, core_1["default"].orbitDb.open(schema.pageKvStore, {
                                fetchEntryTimeout: 5000
                            })];
                }
            });
        });
    };
    SchemaService.prototype.getFriendStoreByWalletAddress = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getSchemaByWalletAddress(walletAddress)];
                    case 1:
                        schema = _a.sent();
                        return [2 /*return*/, core_1["default"].orbitDb.open(schema.friendStore, {
                                fetchEntryTimeout: 5000
                            })];
                }
            });
        });
    };
    SchemaService.prototype.getSiteSettingsStoreByWalletAddress = function (walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getSchemaByWalletAddress(walletAddress)];
                    case 1:
                        schema = _a.sent();
                        return [2 /*return*/, core_1["default"].orbitDb.open(schema.siteSettingsStore, {
                                fetchEntryTimeout: 5000
                            })];
                }
            });
        });
    };
    SchemaService.prototype.reopenStore = function (store) {
        return __awaiter(this, void 0, void 0, function () {
            var orbitAddress;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        orbitAddress = store.address.toString();
                        return [4 /*yield*/, store.close()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, core_1["default"].orbitDb.open(orbitAddress)];
                }
            });
        });
    };
    SchemaService.prototype.dropStore = function (address) {
        return __awaiter(this, void 0, void 0, function () {
            var store;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, core_1["default"].orbitDb.open(address)];
                    case 1:
                        store = _a.sent();
                        return [4 /*yield*/, store.drop()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    SchemaService.prototype.getRepliesPostFeed = function (post, translatedContent) {
        return __awaiter(this, void 0, void 0, function () {
            var repliesFeedName, repliesFeed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        repliesFeedName = this._getRepliesFeedNameSeed(post, translatedContent);
                        return [4 /*yield*/, core_1["default"].orbitDb.feed(repliesFeedName, {
                                accessController: core_1["default"].orbitAccessControl
                            })];
                    case 1:
                        repliesFeed = _a.sent();
                        return [2 /*return*/, repliesFeed];
                }
            });
        });
    };
    SchemaService.prototype.getRepliesPostFeedAddress = function (post, translatedContent) {
        return __awaiter(this, void 0, void 0, function () {
            var feed, address;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getRepliesPostFeed(post, translatedContent)];
                    case 1:
                        feed = _a.sent();
                        address = feed.address.toString();
                        return [2 /*return*/, address];
                }
            });
        });
    };
    SchemaService.prototype.getOrbitAddress = function (orbitCid, walletAddress) {
        return "/orbitdb/" + orbitCid + "/mainStore-" + walletAddress.toLowerCase();
    };
    SchemaService.prototype._getMainStoreNameSeed = function (walletAddress) {
        return "mainStore-" + walletAddress.toLowerCase();
    };
    SchemaService.prototype._getMainFeedNameSeed = function (walletAddress) {
        return "mainFeed-" + walletAddress.toLowerCase();
    };
    SchemaService.prototype._getProfileStoreNameSeed = function (walletAddress) {
        return "profile-" + walletAddress.toLowerCase();
    };
    SchemaService.prototype._getReadOnlyPostFeedNameSeed = function (walletAddress) {
        return "readonly-post-" + walletAddress.toLowerCase();
    };
    SchemaService.prototype._getBlogPostFeedNameSeed = function (walletAddress) {
        return "blog-post-" + walletAddress.toLowerCase();
    };
    SchemaService.prototype._getBlogPostKvStoreNameSeed = function (walletAddress) {
        return "blog-post-kv-" + walletAddress.toLowerCase();
    };
    SchemaService.prototype._getPageKvStoreNameSeed = function (walletAddress) {
        return "page-kv-" + walletAddress.toLowerCase();
    };
    SchemaService.prototype._getFriendStoreNameSeed = function (walletAddress) {
        return "friend-" + walletAddress.toLowerCase();
    };
    SchemaService.prototype._getSiteSettingsStoreNameSeed = function (walletAddress) {
        return "site-settings-" + walletAddress.toLowerCase();
    };
    SchemaService.prototype._getRepliesFeedNameSeed = function (post, translatedContent) {
        var hash = sha256(post.owner + "-" + post.dateCreatedMilli + "-" + translatedContent);
        return "post-" + hash;
    };
    SchemaService.prototype.generateMainStore = function (orbit, accessController, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var mainStoreName;
            return __generator(this, function (_a) {
                mainStoreName = this._getMainStoreNameSeed(walletAddress);
                return [2 /*return*/, core_1["default"].orbitDb.docstore(mainStoreName, {
                        accessController: accessController
                    })];
            });
        });
    };
    SchemaService.prototype.generateSchema = function (orbitdb, accessController, mainStore, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var mainFeed, profileStore, readOnlyPostFeed, blogPostFeed, blogPostKvStore, pageKvStore, siteSettingsStore, friendStore, schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('Generating schema');
                        return [4 /*yield*/, this.generateMainFeed(orbitdb, accessController, walletAddress)];
                    case 1:
                        mainFeed = _a.sent();
                        return [4 /*yield*/, this.generateProfileStore(orbitdb, accessController, walletAddress)];
                    case 2:
                        profileStore = _a.sent();
                        return [4 /*yield*/, this.generateReadOnlyPostFeed(orbitdb, accessController, walletAddress)];
                    case 3:
                        readOnlyPostFeed = _a.sent();
                        return [4 /*yield*/, this.generateBlogPostFeed(orbitdb, accessController, walletAddress)];
                    case 4:
                        blogPostFeed = _a.sent();
                        return [4 /*yield*/, this.generateBlogPostKvStore(orbitdb, accessController, walletAddress)];
                    case 5:
                        blogPostKvStore = _a.sent();
                        return [4 /*yield*/, this.generatePageKvStore(orbitdb, accessController, walletAddress)];
                    case 6:
                        pageKvStore = _a.sent();
                        return [4 /*yield*/, this.generateSiteSettingsStore(orbitdb, accessController, walletAddress)];
                    case 7:
                        siteSettingsStore = _a.sent();
                        return [4 /*yield*/, this.generateFriendStore(orbitdb, accessController, walletAddress)];
                    case 8:
                        friendStore = _a.sent();
                        schema = {
                            mainFeed: mainFeed.address.toString(),
                            profileStore: profileStore.address.toString(),
                            readOnlyPostFeed: readOnlyPostFeed.address.toString(),
                            blogPostFeed: blogPostFeed.address.toString(),
                            blogPostKvStore: blogPostKvStore.address.toString(),
                            pageKvStore: pageKvStore.address.toString(),
                            siteSettingsStore: siteSettingsStore.address.toString(),
                            friendStore: friendStore.address.toString()
                        };
                        return [4 /*yield*/, mainStore.put({
                                _id: walletAddress,
                                value: schema
                            })];
                    case 9:
                        _a.sent();
                        console.log('Inserted schema into mainStore');
                        return [2 /*return*/];
                }
            });
        });
    };
    SchemaService.prototype.updateSchema = function (mainStore, schema, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var schemaUpdated, mainFeed, profileStore, readOnlyPostFeed, blogPostFeed, blogPostKvStore, pageKvStore, siteSettingsStore, friendStore;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        schemaUpdated = false;
                        if (!!schema.mainFeed) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.generateMainFeed(core_1["default"].orbitDb, core_1["default"].orbitAccessControl, walletAddress)];
                    case 1:
                        mainFeed = _a.sent();
                        schema.mainFeed = mainFeed.address.toString();
                        schemaUpdated = true;
                        _a.label = 2;
                    case 2:
                        if (!!schema.profileStore) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.generateProfileStore(core_1["default"].orbitDb, core_1["default"].orbitAccessControl, walletAddress)];
                    case 3:
                        profileStore = _a.sent();
                        schema.profileStore = profileStore.address.toString();
                        schemaUpdated = true;
                        _a.label = 4;
                    case 4:
                        if (!!schema.readOnlyPostFeed) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.generateReadOnlyPostFeed(core_1["default"].orbitDb, core_1["default"].orbitAccessControl, walletAddress)];
                    case 5:
                        readOnlyPostFeed = _a.sent();
                        schema.readOnlyPostFeed = readOnlyPostFeed.address.toString();
                        schemaUpdated = true;
                        _a.label = 6;
                    case 6:
                        if (!!schema.blogPostFeed) return [3 /*break*/, 8];
                        return [4 /*yield*/, this.generateBlogPostFeed(core_1["default"].orbitDb, core_1["default"].orbitAccessControl, walletAddress)];
                    case 7:
                        blogPostFeed = _a.sent();
                        schema.blogPostFeed = blogPostFeed.address.toString();
                        schemaUpdated = true;
                        _a.label = 8;
                    case 8:
                        if (!!schema.blogPostKvStore) return [3 /*break*/, 10];
                        return [4 /*yield*/, this.generateBlogPostKvStore(core_1["default"].orbitDb, core_1["default"].orbitAccessControl, walletAddress)];
                    case 9:
                        blogPostKvStore = _a.sent();
                        schema.blogPostKvStore = blogPostKvStore.address.toString();
                        schemaUpdated = true;
                        _a.label = 10;
                    case 10:
                        if (!!schema.pageKvStore) return [3 /*break*/, 12];
                        return [4 /*yield*/, this.generatePageKvStore(core_1["default"].orbitDb, core_1["default"].orbitAccessControl, walletAddress)];
                    case 11:
                        pageKvStore = _a.sent();
                        schema.pageKvStore = pageKvStore.address.toString();
                        schemaUpdated = true;
                        _a.label = 12;
                    case 12:
                        if (!!schema.siteSettingsStore) return [3 /*break*/, 14];
                        return [4 /*yield*/, this.generateSiteSettingsStore(core_1["default"].orbitDb, core_1["default"].orbitAccessControl, walletAddress)];
                    case 13:
                        siteSettingsStore = _a.sent();
                        schema.siteSettingsStore = siteSettingsStore.address.toString();
                        schemaUpdated = true;
                        _a.label = 14;
                    case 14:
                        if (!!schema.friendStore) return [3 /*break*/, 16];
                        return [4 /*yield*/, this.generateFriendStore(core_1["default"].orbitDb, core_1["default"].orbitAccessControl, walletAddress)];
                    case 15:
                        friendStore = _a.sent();
                        schema.friendStore = friendStore.address.toString();
                        schemaUpdated = true;
                        _a.label = 16;
                    case 16:
                        if (!schemaUpdated) return [3 /*break*/, 18];
                        console.log("Updating schema");
                        return [4 /*yield*/, mainStore.put({
                                _id: walletAddress,
                                value: schema
                            })];
                    case 17:
                        _a.sent();
                        _a.label = 18;
                    case 18: return [2 /*return*/];
                }
            });
        });
    };
    SchemaService.prototype.generateMainFeed = function (orbitdb, accessController, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var mainFeedName;
            return __generator(this, function (_a) {
                console.log("Generating main feed");
                mainFeedName = this._getMainFeedNameSeed(walletAddress);
                return [2 /*return*/, orbitdb.feed(mainFeedName, {
                        create: true,
                        accessController: accessController
                    })];
            });
        });
    };
    SchemaService.prototype.generateProfileStore = function (orbitdb, accessController, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var profileStoreName;
            return __generator(this, function (_a) {
                console.log("Generating profile store");
                profileStoreName = this._getProfileStoreNameSeed(walletAddress);
                return [2 /*return*/, orbitdb.docstore(profileStoreName, {
                        create: true,
                        accessController: accessController
                    })];
            });
        });
    };
    SchemaService.prototype.generateReadOnlyPostFeed = function (orbitdb, accessController, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var readOnlyPostFeedName;
            return __generator(this, function (_a) {
                console.log("Generating read only post feed");
                readOnlyPostFeedName = this._getReadOnlyPostFeedNameSeed(walletAddress);
                return [2 /*return*/, orbitdb.feed(readOnlyPostFeedName, {
                        create: true,
                        accessController: accessController
                    })];
            });
        });
    };
    SchemaService.prototype.generateBlogPostFeed = function (orbitdb, accessController, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var blogPostFeedName;
            return __generator(this, function (_a) {
                console.log("Generating blog post feed");
                blogPostFeedName = this._getBlogPostFeedNameSeed(walletAddress);
                return [2 /*return*/, orbitdb.feed(blogPostFeedName, {
                        create: true,
                        accessController: accessController
                    })];
            });
        });
    };
    SchemaService.prototype.generateBlogPostKvStore = function (orbitdb, accessController, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var blogPostKvStoreName;
            return __generator(this, function (_a) {
                console.log("Generating blog post kv store");
                blogPostKvStoreName = this._getBlogPostKvStoreNameSeed(walletAddress);
                return [2 /*return*/, orbitdb.kvstore(blogPostKvStoreName, {
                        create: true,
                        accessController: accessController
                    })];
            });
        });
    };
    SchemaService.prototype.generatePageKvStore = function (orbitdb, accessController, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var pageKvStoreName;
            return __generator(this, function (_a) {
                console.log("Generating page kv store");
                pageKvStoreName = this._getPageKvStoreNameSeed(walletAddress);
                return [2 /*return*/, orbitdb.kvstore(pageKvStoreName, {
                        create: true,
                        accessController: accessController
                    })];
            });
        });
    };
    SchemaService.prototype.generateFriendStore = function (orbitdb, accessController, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var friendStoreName;
            return __generator(this, function (_a) {
                console.log("Generating friend store");
                friendStoreName = this._getFriendStoreNameSeed(walletAddress);
                return [2 /*return*/, orbitdb.kvstore(friendStoreName, {
                        create: true,
                        accessController: accessController
                    })];
            });
        });
    };
    SchemaService.prototype.generateSiteSettingsStore = function (orbitdb, accessController, walletAddress) {
        return __awaiter(this, void 0, void 0, function () {
            var siteSettingsStoreName;
            return __generator(this, function (_a) {
                console.log("Generating site settings store");
                siteSettingsStoreName = this._getSiteSettingsStoreNameSeed(walletAddress);
                return [2 /*return*/, orbitdb.kvstore(siteSettingsStoreName, {
                        create: true,
                        accessController: accessController
                    })];
            });
        });
    };
    SchemaService.prototype.openAddress = function (address) {
        return __awaiter(this, void 0, void 0, function () {
            var orbitAddress, parsedAddress;
            return __generator(this, function (_a) {
                orbitAddress = new OrbitDBAddress(address.root, address.path);
                parsedAddress = orbitAddress.toString();
                return [2 /*return*/, core_1["default"].orbitDb.open(parsedAddress)];
            });
        });
    };
    return SchemaService;
}());
exports.SchemaService = SchemaService;
