"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var core_1 = require("../core");
var _a = require('ethers'), ethers = _a.ethers, Wallet = _a.Wallet;
var WalletService = /** @class */ (function () {
    function WalletService(walletDao) {
        this.walletDao = walletDao;
    }
    WalletService.prototype.createWallet = function (password) {
        return __awaiter(this, void 0, void 0, function () {
            var wallet, encryptedJsonWallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        wallet = Wallet.createRandom();
                        return [4 /*yield*/, wallet.encrypt(password)];
                    case 1:
                        encryptedJsonWallet = _a.sent();
                        return [4 /*yield*/, this.walletDao.saveWallet(encryptedJsonWallet)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, this.connectWallet(wallet)];
                }
            });
        });
    };
    WalletService.prototype.connectWallet = function (wallet) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        core_1["default"].wallet = wallet;
                        core_1["default"].wallet = core_1["default"].wallet.connect(core_1["default"].provider);
                        _a = window;
                        _b = 'currentAccount';
                        return [4 /*yield*/, core_1["default"].wallet.getAddress()];
                    case 1:
                        _a[_b] = _c.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    WalletService.prototype.unlockWallet = function (password) {
        return __awaiter(this, void 0, void 0, function () {
            var savedWallet, wallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.walletDao.loadWallet()];
                    case 1:
                        savedWallet = _a.sent();
                        if (!savedWallet)
                            throw new Error("No wallet to unlock");
                        return [4 /*yield*/, Wallet.fromEncryptedJson(savedWallet, password)];
                    case 2:
                        wallet = _a.sent();
                        return [2 /*return*/, this.connectWallet(wallet)];
                }
            });
        });
    };
    WalletService.prototype.restoreWallet = function (recoverySeed, password) {
        return __awaiter(this, void 0, void 0, function () {
            var wallet, encryptedJsonWallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        wallet = Wallet.fromMnemonic(recoverySeed);
                        if (!wallet)
                            throw new Error("Error restoring wallet");
                        return [4 /*yield*/, wallet.encrypt(password)];
                    case 1:
                        encryptedJsonWallet = _a.sent();
                        return [4 /*yield*/, this.walletDao.saveWallet(encryptedJsonWallet)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, this.connectWallet(wallet)];
                }
            });
        });
    };
    WalletService.prototype.getWallet = function () {
        return this.walletDao.loadWallet();
    };
    WalletService.prototype.logout = function () {
        core_1["default"].wallet = undefined;
        window['currentAccount'] = undefined;
    };
    return WalletService;
}());
exports.WalletService = WalletService;
